#!/usr/bin/env python

# This is the convusb program, inputs hex character stream (like what's
# dumped by Kai Wang's krepdump.ko kernel module, which has a 4 place hex
# address field, then a single space, then groups of 2 digit bytes) and
# puts out parsed HID code, followed by the hex bytes that drove that line.
# Flag=  -f argument, which changes the input from stdin to whatever comes after
# the -f option 
#
# Thanks go to both Kai Wang and Markus Brueffer, two denizens of the FreeBSD-USB
# mailing list who went WAY out of their way to be of help to me in learning
# what I think is the worst spec I have ever bumped up against.
# Chuck Robey (chuckr@chuckr.org).
# Get the latest version at http://people.freebsd.org/~chuckr/code/python/convusb.py-1.0

import sys, os, os.path, getopt, socket, Tkinter
import parse, items, tables

class nogui(object):
    store = []

    def __init__(self, io, po):
        """This is the array of dictionaries compiled before calling the gui/non-gui.
        The get the field nam:es, call listFields, and to get the descriptions, call
        getFieldDescriptions(fieldName)."""
        self.io = io
        self.po = po
        self.store = self.io.itemStore
        #print self.io.itemStore[1]

    def rF(self,rec, name):
        if name in rec.keys():
            return rec[name]
        else:
            return ''

    def playRecords(self):
        #for p  in range(1, len(self.store)):
        for rec in self.store:
            #print 'rec is %d==' % p,
            #print self.store[p]
            #print '\n\n\n'
            print '%s%s\t%s %s %s %s' % (self.rF(rec,'InputLineCommand'),self.rF(rec,'InputLineData'),
                    self.rF(rec,'Class'), self.rF(rec,'Name'),self.rF(rec,'DecimalData'),
                    self.rF(rec,'CollectionTypes')),
            if 'Units' in rec.keys():
                print ' %s %s %s' % (self.rF(rec,'UnitSystem'),self.rF(rec,'Units'),
                        self.rF(rec,'UnitExponent')),
            print '%s %s' % (self.rF(rec,'UsagePage'),self.rF(rec,'Usage')),
            if 'IOFQualifiers' in rec.keys():
                print '\n\t%s' % self.rF(rec,'IOFQualifiers')
            else:
                print




    def listFields(self):
        pass

    def getFieldDescriptions(self, fieldName):
        pass
        


if __name__ == '__main__':

    pass
    sys.exit(0)

